Subject: bug#45751: [feature/native-comp] emacs keeps running 100% of CPU

From: Édouard Debry <[email-masked]>
Date: Mon, 11 Jan 2021 12:25:56 +0100

On lun., janv. 11 2021, Andrea Corallo wrote:
> Édouard Debry <[email-masked]> writes:
>
>> On dim., janv. 10 2021, Andrea Corallo wrote:
>>> Édouard Debry <[email-masked]> writes:
>>>
>>>> I noticed that when launching emacs on linux (debian buster),
>>>> it keeps on running 100% of the CPU and seems to gradually 
>>>> eat all
>>>> memory, approximately 1-2% every minute.
>>>>
>>>> It seems related to native compiling. In the
>>>> *Async-native-compile-log* I read :
>>>>
>>>> <=============================>
>>>> Compiling
>>>> /home/edouard/.emacs.d/elpa/color-theme-sanityinc-solarized-20200805.603/color-theme-sanityinc-solarized.el...
>>>
>>> I see a similar issue with sanityinc-tomorrow.el, the 
>>> compilation is
>>> way
>>> slower than any other one but it completes eventually.  I 
>>> guess is
>>> the
>>> same issue you see and with sufficient RAM also 
>>> sanityinc-solarized
>>> should complete.
>>>
>>> In case of of sanityinc-tomorrow I think is because of
>>> `color-theme-sanityinc-tomorrow'.  This is a single function 
>>> that
>>> after
>>> macro expansion becomes enormous.
>>>
>>> We need to make the compiler robust against these corner 
>>> cases, I'll
>>> have a look this week into adding some logic for that.
>>>
>>> Thanks
>>>
>>>   Andrea
>>
>> I have waited for approximately one hour and until linux became
>> totally unresponsive, I had to reboot.
>
> Right, these are the classical symptoms of a system swapping for
> insufficient physical memory (or excessive mem usage by a 
> program :)

Probably, my previous bug report "Excessive memory ..." was due to 
this package
trying to be natively compiled. I will try the 
"comp-deferred-compilation-deny-list"
setting on windows 10 so as to be sure there is nothing more.

Regards